#ifndef KEYPAD_H
#define KEYPAD_H

#include <QWidget>
#include <QStackedWidget>
#include <QString>

#include ".ui/ui_vkb1.h"


#define VK_HANGULE  	0x9999
#define VK_ENG			0x9998
#define VK_FINISH		0x9997

class QInputContextHangul;

class VirtualKeyboard : public QWidget{
    Q_OBJECT
public:
    VirtualKeyboard(QInputContextHangul *ic);
    ~VirtualKeyboard();

	void setEditingLabelSetText(QString);
	QString getText();
	void	setText(QString str){ m_ui->vkbedit->setText(str); };
    
	Ui_vkb *m_ui;
	QInputContextHangul *ic;
public slots:
    // Function Key Pad
    void on_setHan_clicked();
    void on_setEng_clicked();
    void on_setNum_clicked();
    void on_BS_clicked();
    void on_RESET_clicked();
    void on_finish_clicked(); // 

    // Eng Key Pad
    void on_A_clicked();
    void on_B_clicked();
    void on_C_clicked();
    void on_D_clicked();
    void on_E_clicked();
    void on_F_clicked();
    void on_G_clicked();
    void on_H_clicked();
    void on_I_clicked();
    void on_J_clicked();
    void on_K_clicked();
    void on_L_clicked();
    void on_M_clicked();
    void on_N_clicked();
    void on_O_clicked();
    void on_P_clicked();
    void on_Q_clicked();
    void on_R_clicked();
    void on_S_clicked();
    void on_T_clicked();
    void on_U_clicked();
    void on_VW_clicked();
    void on_X_clicked();
    void on_Y_clicked();
    void on_Z_clicked();

    // Hangul Key Pad
    void on_H_Q_clicked(); // ㅂ 
    void on_H_W_clicked(); // ㅈ 
    void on_H_E_clicked(); // ㄷ 
    void on_H_R_clicked(); // ㄱ
    void on_H_T_clicked(); // ㅅ
    void on_H_A_clicked(); // ㅁ
    void on_H_S_clicked(); // ㄴ
void on_H_D_clicked(); // ㅇ
void on_H_F_clicked(); // ㄹ
void on_H_G_clicked(); // ㅎ
void on_H_Z_clicked(); // ㅋ
void on_H_X_clicked(); // ㅌ
void on_H_C_clicked(); // ㅊ
void on_H_V_clicked(); // ㅍ
void on_H_K_clicked(); // ㅏㅑ
void on_H_J_clicked(); // ㅓㅕ
void on_H_H_clicked(); // ㅗㅛ
void on_H_N_clicked(); // ㅜㅠ
void on_H_M_clicked(); // ㅡ
void on_H_L_clicked(); // ㅣ
void on_H_O_clicked(); // ㅐㅒ
void on_H_P_clicked(); // ㅔㅖ


    // Num Key Pad
    void on_N_1_clicked();
    void on_N_2_clicked();
    void on_N_3_clicked();
    void on_N_4_clicked();
    void on_N_5_clicked();
    void on_N_6_clicked();
    void on_N_7_clicked();
    void on_N_8_clicked();
    void on_N_9_clicked();
    void on_N_0_clicked();

};

#endif // KEYPAD_H
