
//#include <Python.h> // first here 
//#include <python/Python.h> // first here 

#include <QApplication>
#include <QFile>
#include <QMenu>
#include <QAction>
#include <QTimer>
#include <QFontDialog>

/*
 *
 *	man pty
 *
 *
 *
 */
#include "vterm.h"

#include <stdlib.h> 
#include <stdio.h> 
#include <fcntl.h>
#include <unistd.h> // write(),
#include <sys/types.h>
#include <sys/stat.h>
//#include <stropts.h>
#include <pty.h>
#include <utmp.h> //login_tty()

int max_row,max_column;

//#include <QProcess>
#include <QSocketNotifier>

int Shell::stdinClone = -1;

int amaster,aslave;
QSocketNotifier *mNotifier;
//Screen *screen;
Screen2 *screen;

Shell::Shell()
{
	

	char *pName;
	pName = ttyname(0);
	printf("main ttyname <%s>\n", pName);

	//if (open_pty_pair (amaster, aslave) < 0)
	if (openpty (&amaster, &aslave,NULL,NULL,NULL) < 0)
	{
		printf ("Allocation of pseudo terminal failed");
		exit (0);
	}
	int pid = fork (); /// !!!!!!!!!!!!!!!!!!!!! fork... hmmmm
	if (pid==0)
	{
		//child
		close (amaster);
		//printf("forked!!\n");
		pName = ttyname(aslave);
		printf("slave ttyname <%s>\n", pName);


		login_tty(aslave);
		dup2 (aslave, 0); // STD_IN
		dup2 (aslave, 1); // STDOUT
		dup2 (aslave, 2);
	//	close (aslave);

		execl ("/bin/bash", "bash", (char *) 0); //repace current process!
		//execl ("/bin/ksh", "bash", (char *) 0); //repace current process!
		//execl ("/usr/bin/python", "python", (char *) 0); //repace current process!
		//execv ("/usr/bin/python", NULL); //repace current process!
		//execv ("/bin/bash", NULL); //repace current process!
		//execv ("/usr/bin/mc", NULL); //repace current process!
	}
	else
	{	
		// Parent(Me)
		close (aslave);
		//set_keypress (*amaster);
		
		char *pName;
		//pName = ptsname(amaster);
		//printf("Name of slave side is <%s>\n", pName);

		pName = ttyname(amaster);
		printf("master ttyname <%s>\n", pName);
		
		// Create socket notifier
 	 	mNotifier = new QSocketNotifier( amaster, QSocketNotifier::Read, this );
	  	connect( mNotifier, SIGNAL( activated( int ) ),this, SLOT( readStdout( int ) ) );
	}	

}

void Shell::setupChildProcess()
{
  ::dup2(stdinClone, fileno(stdin));
}

#include <QVector>
#include <QList>

//void putchar_current_cursor(char ch)
void Screen::print_char(char ch)
{
	static char prev_char=0;

	char buf[2];
	buf[0]=ch;
	buf[1]=0;
		
	setOverwriteMode (true);
	QTextCursor c = textCursor();
    //cursor.insertText(QString(QChar::ObjectReplacementCharacter), svgCharFormat);
	c.deleteChar();
	c.insertText(buf);
	setTextCursor(c); //4.5 ?

	prev_char=ch;

}

void Screen::ctrl_char(char ch)
{
	if(ch==0x07)
	{
		return;
	}
	QTextCursor c = textCursor();
	
	if(ch=='\b') //nodelete
	{
	//	screen->moveCursor (QTextCursor::Left);
		c.movePosition(QTextCursor::Left);
	}	
	//	c.deletePreviousChar();
	setTextCursor(c); //4.5 ?
}

void Screen::delchar()
{
	QTextCursor c = textCursor();
	c.deleteChar();
	setTextCursor(c); //4.5 ?
}

// default  fg,bg color
QColor default_color_fg;
QColor default_color_bg;

void Screen::attr(int Ps)
{
	int fg, bg, style;
	QTextCharFormat format;
	if(Ps==0) //default color
	{	
		format.setBackground ( default_color_bg );
		format.setForeground ( default_color_fg );
	}
	else 
	if(Ps==1) //bold
	{
	}
	else
	if(Ps>29)
	{
		int c=Ps%10;
		QColor col;
		
		format.setBackground ( default_color_bg );
		format.setForeground ( default_color_fg );
		
		switch(c)
		{
			case 0 :col=QColor(Qt::black); break;
			case 1: col=Qt::red;	break;
			case 2: col=Qt::green;	break;
			case 3: col=Qt::yellow;	break;
			case 4: col=Qt::blue;	break;
			case 5: col=Qt::magenta;	break;
			case 6: col=Qt::cyan;	break;
			case 7: col=Qt::white;	break;
			default:;
		}

		if(Ps>39)
			format.setBackground(col);
		else 
			format.setForeground(col);

	}
		
	setCurrentCharFormat ( format );
	//setCharFormat ( const QTextCharFormat & format );
}

void Screen::CR()
{
	moveCursor (QTextCursor::StartOfLine); ///
}

void Screen::newline()
{	
	//screen_print_char('\n');
//	moveCursor (QTextCursor::Down);
	//QTextCursor::MoveMode mode = QTextCursor::MoveAnchor )l
	
//	return;
	QTextCursor c = textCursor();
	int pos = c.position();

// Move to beginning of line and insert spaces
	c.movePosition(QTextCursor::EndOfLine);
	c.insertText("\n");
	setTextCursor(c); //4.5 ?

// Move back, and compensate for inserted text...
//	cursor.setPosition(pos + 4);
}
/*
void Screen::start()
{
	moveCursor (QTextCursor::StartOfLine);
} */

// xterm.cpp
void termparse(char *stream,int n)
{
	static QList<char> queue;
	
	for(int i=0; i < n ;i++)
	{
		queue.append(stream[i]);
	}
}

// vtparse.cpp
#include <stdio.h>
#include "vtparse.h"

void parser_callback(vtparse_t *parser, vtparse_action_t action, unsigned char ch)
{
    int i;

   	if(action==VTPARSE_ACTION_PRINT)
	{
		screen->print_char(ch);
		return;
	}
	static bool flag_OSC=false;

   	if(action==VTPARSE_ACTION_OSC_START)
	{
		flag_OSC=true; 
		if(ch==0) // write Window Title name 
			return;
		else ;
	}
   	if( flag_OSC and action==VTPARSE_ACTION_OSC_PUT)
	{
	//	screen_print_char(ch);
		return;
	}
   	if( flag_OSC and action==VTPARSE_ACTION_OSC_START)
	{
		flag_OSC=false; 
		return;
	}


   	if(action==VTPARSE_ACTION_EXECUTE)
	{
		switch(ch)
		{
			case 0x08 :// backspace(no delete)!!
			screen->ctrl_char(0x08);	break;
			case 0x07 :// bell
			screen->ctrl_char(0x07); break;
			case 0x0A :// LF : line feed, newline
			screen->newline();break;
			case 0x0D: // CR : carriage return
			screen->CR(); //moveCursor (QTextCursor::StartOfLine); ///
			break;
			default :
				printf("EXECUTE %d(%c) 0x%X\n",ch,ch,ch);
		}
		return;
	}
		
   	if(action==VTPARSE_ACTION_CSI_DISPATCH)
	{
		switch(ch)
		{
			case 'h': // 
				if(parser->intermediate_chars[0]=='?')
				{
					if(parser->params[0]==1034) 
						//Interpret "meta" key, sets eighth bit. (enables the eightBitInput resource).
						;
					return;	
				}
				break;
			case 'H': // cursor Position
				if(parser->num_params==0) ;//doPos(1,1);
				break;
			case 'J': // clear
				if(parser->params[0]==2)
					screen->clear();
					; // all clear
				break;
			case 'K': //delete line 
				screen->delchar();
			//	printf("parm [%d]\n", parser->params[0]);
				break;
			case 'm':  // attr, color 
				for(int i=0;i<parser->num_params;i++)
					screen->attr(parser->params[i]);
				return;
			default: ;
		}
	//	return;
	}

	printf("Received action %s, char=%d(%c)\n", ACTION_NAMES[action],ch,ch);

	if(parser->intermediate_chars[0]!=0)
    	printf("Intermediate chars: '%s'\n", parser->intermediate_chars);
	
	if(parser->num_params>0)
	{
		printf("%d Parameters:\n", parser->num_params);
		for(i = 0; i < parser->num_params; i++)
			printf("\t%d\n", parser->params[i]);
		printf("\n");

	}
}

vtparse_t parser;
void vtermparse(unsigned char *stream,int n)
{
	static bool flag_init=false;
	if(flag_init==false)
	{
    	vtparse_init(&parser, parser_callback);
		flag_init=true;
	}

	vtparse(&parser, stream, n);
}


// MOVETO Screen or Terminal  
void Shell::readStdout(int /*fd*/)
{
	int n;
	unsigned char obuf[64]; //XXX SEGFAULT
	///int k=lseek(amaster,0,SEEK_END);
	
	n = read(amaster, obuf, sizeof (obuf-1));
	//	n = read(amaster, obuf, sizeof (obuf-1)); //blocking!!
	obuf[n]=0;
	vtermparse(obuf,n);
	for(int i=0; i<n ;i++)
	{
		if(obuf[i]==27) 
			obuf[i]='^';
	}
	//printf("read: n=%d |%s|\n",n,obuf);
	
	//while( n >0 )
	{
    	
	}
}

void Shell::readOut(){
	printf("read\n");
}
void Shell::cmd_ok(){}
void Shell::cmd_started()
{
	printf("stated\n");
	///ps->write("ls\r");
}

void Shell::cmd_finished(int ,QProcess::ExitStatus )
{
}

void Shell::cmd_error(QProcess::ProcessError )
{
}

void Shell::putch(char ch)
{
	//ps->putChar(ch);
	//	ch = fgetc (stdin);
	if (ch > 0)
	{
	//	printf ("writing to the master [%c]\n",ch);
		//if(file->putChar(ch)==false)
		//file->flush();
		if (write (amaster, &ch, 1) < 0)
		{
			printf("error writing to the master ");
		}
	}
}



//#include <QTimerEvent>
#include <QVBoxLayout>
#include <QTextEdit>
#include <QApplication>

#include <QMenuBar>
#include <QMenu>

Shell *sh;
StatusBar *statusbar=0;
VTerm::VTerm()
{
//	test();
	QVBoxLayout *vlayout = new QVBoxLayout;
	vlayout->setMargin(0);
	vlayout->setSpacing(0);
	//vlayout->addWidget( splitter);
	//vlayout->addWidget( statusBar);
	setLayout(vlayout);
	//QTextEdit *screen=new QTextEdit();
	//QTextEdit *debug_screen=new QTextEdit();
	//vlayout->addWidget( debug_screen);
	QMenuBar *menubar = new QMenuBar;
	QMenu *m_command = new QMenu("Command",this);	// filled in later

	menubar->addMenu(m_command);
//	menu->addMenu(m_view);
//	menu->addSeparator();
	vlayout->setMenuBar(menubar);
	
	QAction *act=new QAction("font select...",this);
	m_command->addAction(act);
	connect(act, SIGNAL(triggered(bool)), this, SLOT(run_fontsel(bool)));
	
//	screen=new Screen(); vlayout->addWidget( screen);
	screen=new Screen2(this);
	vlayout->addWidget( screen);
	
	statusbar=new StatusBar(this);
	vlayout->addWidget( statusbar);
	sh=new Shell();
	sh=0;

//	void QTextEdit::textChanged () 
//	connect(debug, SIGNAL(textChanged()), this, SLOT(tmp_write()));
	
	settings_load();
	show();
}

void VTerm::run_fontsel(bool check)
{
//	printf("b=%d\n",check);
//	if(b==false) return;
//	QFontDialog 
	screen->setFont(QFontDialog::getFont(0, screen->font()));
	//screen->setFont(QFontDialog::getFont(0, screen->font()));
	//screen2->setFont(QFontDialog::getFont(0, screen->font()));
}

#include <QTextCursor>
Screen::Screen()
{
	//setAttribute( Qt::WA_InputMethodEnabled );
//	QTextCharFormat charFormat;
///	setTextCursor(cursor);
//	setCurrentCharFormat (charFormat ); //append?
//	setOverwriteMode (true);
 
//	setLineWrapMode (QTextEdit::FixedColumnWidth);
//	setLineWrapColumnOrWidth (80);
	//setReadOnly ( true );
// QColorDialog
//void QTextEdit::setTextBackgroundColor ( const QColor & c )   [slot] //4.4
// void QTextEdit::setTextColor ( const QColor & c )   [slot]
}

void Screen::reset()
{
	setTextBackgroundColor (default_color_bg );
	setTextColor (default_color_fg);
}

void Screen::eraseAll()
{
}

#include <QKeyEvent>
void Screen::keyPressEvent ( QKeyEvent * e )
{
//	void Ter::keyPressEvent ( QKeyEvent * e )
	int k=e->key();

	switch(k)
	{
		case Qt::Key_Return:
			//printf("keyPressEvent() Enter\n");
			sh->putch('\r'); break;
		case Qt::Key_unknown:
			printf("keyPressEvent()  unknwon=%s\n",qPrintable(e->text()));
			break;
		case Qt::Key_Backspace:
			sh->putch('\b'); break;
		case Qt::Key_Up:
			sh->putch(27);sh->putch('['); sh->putch('A');break;
		case Qt::Key_Down:
			sh->putch(27);sh->putch('['); sh->putch('B');break;
		case Qt::Key_Right:
			sh->putch(27);sh->putch('['); sh->putch('C');break;
		case Qt::Key_Left:
			sh->putch(27);sh->putch('['); sh->putch('D');break;
		default:
			QString str;
			str=e->text(); // return unicode 
			printf("Default keyPressEvent() %d %c(%s)\n",k,k,qPrintable(str));

			if(str.length()==1)
			{	
				char ch;
				ch=str[0].toAscii();
				sh->putch(ch); //ctrl+r 
			}
			else
			{

			}
			//else 
	}

}

#include <QInputMethodEvent>

// when called , HAN/ENG key pressed...
/*
void Screen::inputMethodEvent(QInputMethodEvent * e)
{
	//printf("inputMethodEvent()\n");
    QString commitString = e->commitString();
    if (!commitString.isEmpty()) {
		printf("inputMethodEvent worksk?\n");
//        emit inputEvent(commitString);
    }
    QString preeditString = e->preeditString();
 
 	if (m_inputContent == NULL){
        m_inputContent = new Input(this, m_nCharWidth, m_nCharHeight, m_nCharAscent);
        m_inputContent->setFont(*m_pFont);
    }
    if (preeditString.isEmpty()) {
        m_inputContent->hide();
    } else {
        m_inputContent->drawInput(e);
        QPoint cursor;
        int x = m_pBuffer->caretX();
        int y = m_pBuffer->caretY();
        cursor = mapToPixel(QPoint(x+1,y));

        if (m_inputContent->width() + cursor.x() > m_rcClient.width()){
            cursor = mapToPixel(QPoint(x,y));
            cursor.setX(m_rcClient.right() - m_inputContent->width());
        }else
            cursor = mapToPixel(QPoint(x,y));
        m_inputContent->show();
        m_inputContent->move(cursor);
    }
}
*/
/*
QVariant Screen::inputMethodQuery(Qt::InputMethodQuery property) const
{
	 //  qDebug()<<"inputMethodQuery";
    switch (property) {
    case Qt::ImMicroFocus:
    //    return QVariant(QRect((m_pBuffer->caret().x() + 1)*m_nCharWidth, (m_pBuffer->caret().y() + 1)*m_nCharHeight, m_nCharWidth, m_nCharHeight));
    case Qt::ImFont:
//        return QVariant(*m_pFont);
    case Qt::ImCursorPosition:
//        return m_pBuffer->caret().x();
    default:
        return QVariant();
    } 
} */

// Location: bottom
StatusBar::StatusBar(QWidget *parent)  : QStatusBar(parent)
{
	setSizeGripEnabled (true);
//	QWidget *le = new QLabel(this);//QButton *button = new QButton(this);
//	QLineEdit *le=new QLineEdit(this);

//	showMessage ( const QString & message, int timeout = 0 )	
//	showMessage("aaaaaa");
	label = new QLabel(this);//QButton *button = new QButton(this);
	//label->setText ("") ;
	label->setFrameShape(QFrame::NoFrame);
	label->setText("label1");	
	
	//label->setFrameShape (QFrame::StyledPanel);
	//label->setFrameShape (QFrame::Panel);
	//label->setFrameShape (QFrame::WinPanel);
	//label->setFrameShadow(QFrame::Sunken);
//	button2 = new QToolButton(this);//QButton *button = new QButton(this);
//	button2->setTextLabel ("") ;
//	button2->setUsesTextLabel ( true );
//	button2->setAutoRaise(true); 
//	button3 = new QLabel(this);//QButton *button = new QButton(this);
//	button3->setText ("") ;
//	addPermanentWidget(label);
	addWidget(label);
//	addPermanentWidget(le,1);
}

void StatusBar::refresh()
{
	QString str;
	str.sprintf("row: %d col:%d",max_row,max_column);
	label->setText(str);	
}

extern	int num_opened_files;
void StatusBar::update(int ) //total
{
	QString str;
//	int 	x=0;
//	label->setText("Process count: " + str.setNum(total_n) ) ;
//	button2->setTextLabel ("Network Process(testing): "+ str.setNum(Procinfo::num_network_process));
//	button3->setText ("Opened files : "+ str.setNum(num_opened_files));
}


/*
void VTerm::tmp_write()
{
	ps->write("env\r");
} */

int main(int argc, char *argv[])
{
	printf("x2073\n");
 	QApplication app(argc, argv);
    VTerm vterm;
    vterm.show();
	
    return app.exec();
}


char* settings_path(char *name)
{
	char *home = getenv("HOME");
	if(!home) return 0;
	strcpy(name, home);
	strcat(name, "/.vtermrc");
	return name;
}

/* Don't modify !!!! (by fasthyun@show.co.kr) 
 Description :
 	1. only called when in visible() state.
 	2. called when clicked  WINDOW_EXIT_X_BUTTON  
 	3. called when user logout (session manager) 
	commitData() ???
*/
void VTerm::closeEvent(QCloseEvent *e) 
{
	printf("DEBUG: closeEvent()....\n");
	e->accept(); // ok. I will be exit Now !! 
	settings_save();
}

#include <QSettings>
//extern QList<watchCond *> watchlist;

bool VTerm::settings_load()
{
	char path[512];
	if(settings_path(path)==NULL)
	{
		return false;
	}
	QSettings set(path,QSettings::NativeFormat);

	default_color_fg.setRgb(20,30,20);
	default_color_bg.setRgb(255,255,255);
	screen->reset();
	
	//int v=set.value("version",0).toInt();
	//if(v==0) return false;
	
	int x, y, w, h;
	x=set.value("geometry/x").toInt();
	y=set.value("geometry/y").toInt();
	w=set.value("geometry/width").toInt();
	h=set.value("geometry/height").toInt();
	// set.value("geometry/visiable",isVisible()); 
	// Qps::flag_show=true;
	setGeometry(x, y, w, h);

	
	 if(set.value("font/name")!=QVariant() and set.value("font/size")!=QVariant() )
	{
		QString fname=set.value("font/name").toString();
		int	 fsize=set.value("font/size").toInt();	// if not exist then 0
		QFont font;
		font.setFamily (fname);
		font.setPointSize(fsize);
		screen->setFont(font);
	}

	
	// Field 
	/* QStringList sl=set.value("field").toStringList();
	for(int i=0;i<sl.size();i++)
	{
		QString str=sl[i];
		procview->addField(str.toAscii().data());
	}
	*/

	//QString str=set.value("sort/field").toString(); 
	/*
	sl=set.value("flags").toStringList();
	//for(int i=0;i<sl.size();i++)
	for(Sflagvar *fs = flagvars; fs->name; fs++) 
	{
		if(sl.contains(fs->name))
			*(fs->var)=true;
		else 
			*(fs->var)=false;
	} */

//	int i=set.value("interval").toInt();

	/* 
	size=set.beginReadArray ("commands");
 	for(int i = 0; i < size; i++) {
		set.setArrayIndex(i);
		Command *c=new Command;
		c->putString(set.value("cmd").toString());
		commands.append(c);
	}
	set.endArray();	
	*/

	return true;
}


// USING : 
// write geometry, visible fields and other settings to $HOME/.vtermrc
bool VTerm::settings_save() //save setting
{
	char path[512];
	if(settings_path(path)==NULL)
	{
		return false;
	}

	QSettings set(path,QSettings::NativeFormat);
	
	//set.setValue("version",QPS_FILE_VERSION);
	//set.beginGroup("");
	//set.endGroup();
	set.setValue("geometry/x",pos().x());
	set.setValue("geometry/y",pos().y());
	set.setValue("geometry/width",width());
	set.setValue("geometry/height",height());
	set.setValue("geometry/visiable",isVisible()); //isVisible() ? "show":"hide");

	QStringList sl;
	//printf("procview cats.size=%d\n",procview->cats.size());
//	set.setValue("field",procview->customfields);
//	set.setValue("F_CMD",procview->idxF_CMD);

	//	return;
	sl.clear();
	/*for(Sflagvar *fs = flagvars; fs->name; fs++) 
	{
		if(*(fs->var))
			sl.append(fs->name);
	} */
	set.setValue("flags",sl);

	sl.clear();
	set.setValue("font/name",screen->font().family());
	set.setValue("font/size",screen->font().pointSize()); 
	//set.setValue("interval",update_period);

/*	set.beginWriteArray ("commands");
 	for(int i = 0; i < commands.size(); i++) {
		set.setArrayIndex(i);
//		set.setValue("cmd", commands[i]->getString());
	}
	set.endArray();
	*/
	return true;
}



/*
int open_pty_pair (int *amaster, int *aslave)
{
	int master, slave;
	char *name;

	master = getpt ();
	if (master < 0)
		return 0;

	if (grantpt (master) < 0 || unlockpt (master) < 0)
		goto close_master;
	name = ptsname (master);
	if (name == NULL)
		goto close_master;

	printf("name=%s\n",name);

	slave = open (name, O_RDWR);
	if (slave == -1)
		goto close_master;

	if (isastream (slave))
	{
		if (ioctl (slave, I_PUSH, "ptem") < 0
				|| ioctl (slave, I_PUSH, "ldterm") < 0)
			goto close_slave;
	}

	*amaster = master;
	*aslave = slave;
	return 1;

close_slave:
	close (slave);

close_master:
	close (master);
	return 0;
}
#include <errno.h>
#include <fcntl.h>
//#include <sys/stropts.h>
#include <sys/signal.h>
#include <sys/ioctl.h>
#include <sys/stat.h>
int open_pty_pair (int *amaster, int *aslave)
{
	int master, slave;
	char *name;
	master = getpt ();
	if (master < 0)
	{
		perror ("The master pty couldn't be opend");
		return -1;
	}
	if (grantpt (master) < 0 || unlockpt (master) < 0)
	{
		perror ("Grant pt failed ");
		close (master);
		return -1;
	}
	name = ptsname (master);
	if (name == NULL)
	{
		perror ("Error getting the master name");
		close (master);
		return -1;
	}
	slave = open (name, O_RDWR);
	if (slave == -1)
	{
		perror ("Error opening the slave");
		close (master);
		return -1;
	}
	// ??
	if (isastream (slave))
	{
		if (ioctl (slave, I_PUSH, "ptem") < 0 || ioctl (slave, I_PUSH, "ldterm") < 0)
		{
			perror ("Streams file : ioctl failed");
			close (master);
			close (slave);
			return -1;
		}
	}
	*amaster = master;
	*aslave = slave;
	return 1;
}

*/

int chars[240][320];
int attrs[240][320];

int cursor_x=10,cursor_y=10;
int font_width,font_height;
TermCursor xcursor;

Screen2::Screen2(QWidget *p)
{
	max_row=24,max_column=80; //default size
	setMinimumHeight (80);
	reset();
//	font_width=fontMetrics().maxWidth();
//	font_height=fontMetrics().height();
	setFocusPolicy ( Qt::StrongFocus);
	//setSizePolicy ( QSizePolicy::Preferred,QSizePolicy::Preferred);
	setSizePolicy ( QSizePolicy::Preferred,QSizePolicy::Expanding);

	QTimer *timer = new QTimer(this);
	connect(timer, SIGNAL(timeout()), this, SLOT(timer_update())); // update();
	timer->start(300);
}

void Screen2::setFont(QFont font)
{
	QWidget::setFont(font);
	font_width=fontMetrics().maxWidth();
	font_height=fontMetrics().height();
	printf("setFont() (%d,%d)\n",font_width,font_height);
}
void Screen2::resizeEvent ( QResizeEvent * e )
{
	max_column=e->size().width()/font_width;
	max_row=e->size().height()/font_height;
	statusbar->refresh();
	QWidget::resizeEvent(e);
}

//
#include <QPainter>

int cache[250][250];
void Screen2::paintEvent(QPaintEvent *e)
{
	//QWidget::paintEvent(e);
	QPainter p(this);
	
	p.setBackground(default_color_bg);
	p.eraseRect (e->rect());
	
	QRect updateR=e->rect();

//	if(updateR.width()<viewR.width() or updateR.height()<viewR.height())
	{
	//when: Scroll_up,down and Selection 
	//printf("partial: %d!=%d, %d!=%d\n",updateR.width(),viewR.width(),updateR.height(),viewR.height());
	//printf("viewR (%d,%d,%d,%d) \n",viewR.x(),viewR.y(),viewR.width(),viewR.height());
	}
//	else 
	{
//		flag_fullpainting=true;
	///	printf("%s::paintEvent() fullpainting %d\n",objectName().toAscii().data(),count++);
	}
	

    int firstRow = findRow( updateR.y() );
    int firstCol = findCol( updateR.x() );

    int	 xStart, yStart;
   
	for(int r=0;r<max_row;r++)
	{
		for(int c=0;c<max_column;c++)
		{
			QString str;
			int ch=chars[r][c];
			//if(ch!=0)
			if(ch!=cache[r][c])
			{
			//	QRect rect(font_width*c, font_height*r, font_width,font_height);
			//	p.eraseRect (rect);
				str=QChar(ch);
				//QRect rect;
				//p.drawText(c*font_width,r*font_height + font_height,str);
				//p.drawText(c*font_width,r*font_height,font_width,font_height,Qt::AlignCenter,str);
				p.drawText(c*font_width,r*font_height,font_width,font_height,0,str);
				cache[r][c]=ch;
			}
		}
	}

	drawCursor(p);
}
/*

	if ( !colXPos( firstCol, &xStart ) ) { 
		// right empty area of table 
		//paint.eraseRect( updateR ); // erase area outside cells but in view 
		//printf("colXPos null\n");
		eraseRight(&paint, updateR);
		return;
	} 

	//if ( !rowYPos( firstRow, &yStart ) || !colXPos( firstCol, &xStart )  ) 	
	if ( !rowYPos( firstRow, &yStart ) ) {	 //get firstRow   
		//printf("eraseRect()\n");
		paint.eraseRect( updateR );
		return;
	} 

	int	  maxX	= updateR.right();	// x2
    int	  maxY	= updateR.bottom();	// y2
    int	  row	= firstRow; 
    int	  col;
    int	  yPos	= yStart;
    int	  xPos = maxX+1; // in case the while() is empty
    int	  nextX;
    int	  nextY;
	
*/ 
int Screen2::yposRow(int r)
{
	return r*font_height;
}

static int lastState=0;
void Screen2::timer_update()
{
	lastState=!lastState;
	updateCell(xcursor.y,xcursor.x);
}
// QTimer timer 
// 
void Screen2::drawCursor(QPainter &p) 
{

//	int cursor_x,cursor_y;
	if(lastState) 
	{
		p.fillRect ( font_width*xcursor.x, font_height*xcursor.y, font_width,font_height,QColor(0,255,0));
	}
	else
	{
	//	p.fillRect ( font_width*xcursor.x, font_height*xcursor.y, font_width,font_height,QColor(0,255,0));
	}
//	update
}

//void Screen2::size() 
void Screen2::newline()
{
	if(max_row-1 <=xcursor.y)
	//if(max_row<=xcursor.y)
	{
		//		chars[xcursor.y][xcursor.x]=c;
		for(int r=0;r<max_row;r++)
		{
			for(int c=0;c<max_column;c++)
			{
				chars[r][c]=chars[r+1][c];
			}
		}
		
		for(int c=0;c<max_column;c++)
			chars[max_row-1][c]=0;
	}
	else 
		xcursor.y++;
}

void Screen2::redraw(){}
void Screen2::reset()
{
	clear();
}
void Screen2::eraseAll()
{}
void Screen2::clear()
{
	for(int r=0;r<max_row;r++)
	{
		for(int c=0;c<max_column;c++)
		{
			chars[r][c]=0;
		}
	}
	xcursor.x=0;
	xcursor.y=0;
}
void Screen2::updateCell(int r,int c)
{
//	font_width*xcursor.x, font_height*xcursor.y, font_width,font_height
	QRect rect(font_width*c, font_height*r, font_width,font_height);
	update(rect);
}

void Screen2::print_char(char c)
{
//	printf("xxx=%c\n",c);
	chars[xcursor.y][xcursor.x]=c;
	updateCell(xcursor.y,xcursor.x);
	xcursor.x++;
}
void Screen2::ctrl_char(char c)
{

}

void Screen2::delchar()
{
	xcursor.x--;
	chars[xcursor.y][xcursor.x]=0;
	update();
}

void Screen2::CR()
{
	xcursor.x=0;
}

void Screen2::attr(int Ps)
{}

void Screen2::keyPressEvent ( QKeyEvent * e )
{
//	void Ter::keyPressEvent ( QKeyEvent * e )
	int k=e->key();

	switch(k)
	{
		case Qt::Key_Return:
		//	printf("keyPressEvent() Enter\n");
			sh->putch('\r'); break;
		case Qt::Key_unknown:
			printf("keyPressEvent()  unknwon=%s\n",qPrintable(e->text()));
			break;
		case Qt::Key_Backspace:
			sh->putch('\b'); break;
		case Qt::Key_Up:
			sh->putch(27);sh->putch('['); sh->putch('A');break;
		case Qt::Key_Down:
			sh->putch(27);sh->putch('['); sh->putch('B');break;
		case Qt::Key_Right:
			sh->putch(27);sh->putch('['); sh->putch('C');break;
		case Qt::Key_Left:
			sh->putch(27);sh->putch('['); sh->putch('D');break;
		default:
			QString str;
			str=e->text(); // return unicode 
		//	printf("Default keyPressEvent() %d %c(%s)\n",k,k,qPrintable(str));

			if(str.length()==1)
			{	
				char ch;
				ch=str[0].toAscii();
				sh->putch(ch); //ctrl+r 
			}
			else
			{

			}
			//else 
	}

}


int	xmain ()
{
		/* struct termios new_settings;
		if (tcgetattr (0, &new_settings) < 0)
		{
			perror ("Error getting the attributes for terminal 0");
			exit (0);
		}
		new_settings.c_lflag &= (~ECHO);
		if (tcsetattr (0, TCSANOW, &new_settings) < 0)
		{
			perror ("Error unsetting echo for terminal 0");
			exit (0);
		}

		int flags;
		if ((flags = fcntl (*amaster, F_GETFL, 0)) < 0)
		{
			perror ("fcntl:getfl failed\n");
			exit (-1);
		}
		flags |= O_NONBLOCK;
		if (fcntl (*amaster, F_SETFL, flags) < 0)
		{
			perror ("Fcntl:setfl failed\n");
			exit (-1);
		}

		int ppid = fork ();
		if (!ppid)
		{
			int ch;
			set_keypress (0);
			while (1)
			{
				ch = fgetc (stdin);
				if (ch > 0)
				{
					if (write (*amaster, &ch, 1) < 0)
					{
						perror ("error writing to the master ");
					}
				}
			}
		}
		else
		{
			int len;
			char buffer;
			dup2 (*amaster, 0);
			while (1)
			{
				if ((buffer = fgetc (stdin)) != -1)
				{
					fprintf (stdout, "%c", buffer);
				}
			}
		}
	}

	if(0){

			int flags;
			if ((flags = fcntl (amaster, F_GETFL, 0)) < 0)
			{
				perror ("fcntl:getfl failed\n");
				exit (-1);
			}
			flags |= O_NONBLOCK;
			if (fcntl (amaster, F_SETFL, flags) < 0)
			{
				perror ("Fcntl:setfl failed\n");
				exit (-1);
			} 
		}

	waitpid (pid, NULL, 0); 
	
		if(0)
		{
	
			file=new QFile("test");
			printf("amaster=%d \n",amaster);
			if(file->open(amaster,QIODevice::ReadWrite )==true)
				//if(file->open(amaster,QIODevice::ReadWrite | QIODevice::Unbuffered)==true)
				printf("open!!\n");
			connect(file, SIGNAL(readyRead()), this, SLOT(readOut()));
			file->waitForReadyRead ( 3000 ) ;
			printf("size=%d\n",(int)file->bytesAvailable ());
		}

		
	if (0) 
	{
		QProcess *ps;
		ps=new QProcess;	// leak?
		//connect(okButton, SIGNAL(clicked()), this, SLOT(cmd_ok()));
		connect(ps, SIGNAL(started()), this, SLOT(cmd_started()));
		connect(ps, SIGNAL(finished ( int , QProcess::ExitStatus )),this,SLOT(cmd_finished ( int , QProcess::ExitStatus )));
		connect(ps, SIGNAL(error ( QProcess::ProcessError )),this, SLOT(cmd_error(QProcess::ProcessError)));
		connect(ps, SIGNAL(readyRead()), this, SLOT(readOut()));
		connect(ps, SIGNAL(readyReadStandardOutput()), this, SLOT(readOut()));
		ps->start("python",QIODevice::ReadWrite);		// thread run, if null then segfault occurs. ?

	// 	ps->setReadChannelMode(QProcess::SeparateChannels);
		if (stdinClone == -1)
			stdinClone = ::dup(fileno(stdin)); 
		return;
	}

	*/
	return 0;
}

/*
int python()
{
  Py_Initialize();
  PyRun_SimpleString("from time import time,ctime\n"
                     "print 'Today is',ctime(time())\n");
  Py_Finalize();
  return 0;
} */

