/*
flex(lex): token generator
bison(yacc) : parser 
http://invisible-island.net/xterm/ctlseqs/ctlseqs.html
*/


Ps : single number (optional)
Pm : multiple number 
Pt : text
OSC 
ST : string end

// VT100 Mode

//Most of these control sequences are standard VT102 control sequences, but there is support for later DEC VT terminals (i.e., VT220, VT320, VT420), as well as ISO 6429 and aixterm color controls. The only VT102 features not supported is auto-repeat, since the only way X provides for this will affect all windows. There are additional control sequences to provide xterm-dependent functions, such as the scrollbar or window size. Where the function is specified by DEC or ISO 6429, the code assigned to it is given in parentheses. The escape codes to designate and invoke character sets are specified by ISO 2022; see that document for a discussion of character sets.


//Single-character functions

BEL		doBell();		//Bell (Ctrl-G)
BS		doBackSpace();	//Backspace (Ctrl-H)
CR		doCR();			//Carriage Return (Ctrl-M)
ENQ		doReturn();		//Return Terminal Status (Ctrl-E). Default response is an empty string, but may be overridden by a resource answerbackString.
FF		doFormFeed();	//Form Feed or New Page (NP) (Ctrl-L) same as LF
LF		doLineFeed();	//Line Feed or New Line (NL) (Ctrl-J)
SP		doSpace();		//Space.
TAB		doTab();		//Horizontal Tab (HT) (Ctrl-I)
VT		doVTab();		//Vertical Tab (Ctrl-K) same as LF
SO		doShiftOut();	//Shift Out (Ctrl-N) → Switch to Alternate Character Set: invokes the G1 character set.
SI		doShiftIn();	/* Shift In (Ctrl-O) → Switch to Standard Character Set: invokes the G0 character set (the default). Controls beginning with ESC (other than those where ESC is part of a 7-bit equivalent to 8-bit C1 controls), ordered by the final character(s). */
ESC SP F	do7bitCTRL();	//7-bit controls (S7C1T).
ESC SP G	do8bitCTRL();	//8-bit controls (S8C1T).
/*
ESC SP L	Set ANSI conformance level 1 (dpANS X3.134.1).
ESC SP M	Set ANSI conformance level 2 (dpANS X3.134.1).
ESC SP N	Set ANSI conformance level 3 (dpANS X3.134.1).
ESC # 3		DEC double-height line, top half (DECDHL)
ESC # 4		DEC double-height line, bottom half (DECDHL)
ESC # 5		DEC single-width line (DECSWL)
ESC # 6		DEC double-width line (DECDWL)
ESC # 8		DEC Screen Alignment Test (DECALN)
ESC % @		Select default character set, ISO 8859-1 (ISO 2022)
ESC % G		Select UTF-8 character set (ISO 2022)
ESC ( C		Designate G0 Character Set (ISO 2022)
ESC ) C		Designate G1 Character Set (ISO 2022)
ESC * C		Designate G2 Character Set (ISO 2022)
ESC + C		Designate G3 Character Set (ISO 2022)
*/
/*
Final character C for designating character sets (0 , A and B apply to VT100 and up, the remainder to VT220 and up):
C = 0 → DEC Special Character and Line Drawing Set
C = A → United Kingdom (UK)
C = B → United States (USASCII)
C = 4 → Dutch
C = C or 5 → Finnish
C = R → French
C = Q → French Canadian
C = K → German
C = Y → Italian
C = E or 6 → Norwegian/Danish
C = Z → Spanish
C = H or 7 → Swedish
C = = → Swiss
*/

ESC 7		doSaveCursor();			//Save Cursor (DECSC)
ESC 8		doRestoreCurosor();		//Restore Cursor (DECRC)
ESC =		activateKepad();		//Application Keypad (DECPAM)
ESC >		activateNormalKeypad();	//Normal Keypad (DECPNM)
ESC F		moveCursor();			//Cursor to lower left corner of screen (if enabled by the hpLowerleftBugCompat resource).
ESC c		doReset();				//Full Reset (RIS)
//ESC l		Memory Lock (per HP terminals). Locks memory above the cursor.
//ESC m		Memory Unlock (per HP terminals)
//ESC n		Invoke the G2 Character Set as GL (LS2).
//ESC o		Invoke the G3 Character Set as GL (LS3).
//ESC |		Invoke the G3 Character Set as GR (LS3R).
//ESC }		Invoke the G2 Character Set as GR (LS2R).
//ESC ~		Invoke the G1 Character Set as GR (LS1R).

/* Application Program-Control functions
APC Pt ST xterm implements no APC  functions; Pt is ignored.  Pt need
          not be printable characters.

Device-Control functions
DCS Ps; Ps| Pt ST
          User-Defined Keys (DECUDK).  The first parameter:
            Ps = 0  -> Clear all UDK definitions before starting
          (default)
            Ps = 1  -> Erase Below (default)
          The second parameter:
            Ps = 0  -> Lock the keys (default)
            Ps = 1  -> Do not lock.
          The third parameter is a ';'-separated list of strings denot-
          ing the key-code separated by a '/' from the hex-encoded key
          value.  The key codes correspond to the DEC function-key codes
          (e.g., F6=17).
DCS $ q Pt ST
          Request Status String (DECRQSS).  The string following the "q"
          is one of the following:
            " q     -> DECSCA
            " p     -> DECSCL
            r       -> DECSTBM
            m       -> SGR
          xterm responds with DCS 1 $ r Pt ST for valid requests,
          replacing the Pt with the corresponding CSI string, or DCS 0 $
          r Pt ST for invalid requests.
DCS + q Pt ST
          Request Termcap/Terminfo String (xterm, experimental).  The
          string following the "q" is a list of names encoded in hex-
          adecimal (2 digits per character) separated by ; which corre-
          spond to termcap or terminfo key names.
          xterm responds with DCS 1 + r Pt ST for valid requests, adding
          to Pt an = , and the value of the corresponding string that
          xterm would send, or DCS 0 + r Pt ST for invalid requests.
          The strings are encoded in hexadecimal (2 digits per charac-
          ter).
*/

/*   doSomething(int *pm,int n);  */

Functions using CSI , ordered by the final character(s)

// single
CSI u     doSaveCursor();	//Save cursor (ANSI.SYS)
CSI ! p   doSoftReset();	//Soft terminal reset (DECSTR)

//
CSI ? Pm i	  /* Media Copy (MC, DEC-specific)
            Ps = 1  -> Print line containing cursor
            Ps = 4  -> Turn off autoprint mode
            Ps = 5  -> Turn on autoprint mode
            Ps = 1  0  -> Print composed display, ignores DECPEX
            Ps = 1  1  -> Print all pages */
CSI ? Ps J	doClear(%d);	 /*  Erase in Display (DECSED)
            Ps = 0  -> Selective Erase Below (default)
            Ps = 1  -> Selective Erase Above
            Ps = 2  -> Selective Erase All */
CSI ? Ps K doClearLine(%d);		/* Erase in Line (DECSEL)
            Ps = 0  -> Selective Erase to Right (default)
            Ps = 1  -> Selective Erase to Left
            Ps = 2  -> Selective Erase All */
CSI ? Ps n 
		/*		
		Device Status Report (DSR, DEC-specific)
            Ps = 6  -> Report Cursor Position (CPR) [row;column] as CSI? r ; c R (assumes page is zero).
            Ps = 1 5  -> Report Printer status as CSI ? 1 0  n  (ready) or CSI ? 1 1  n  (not ready)
            Ps = 2 5  -> Report UDK status as CSI ? 2 0  n  (unlocked) or CSI ? 2 1  n  (locked)
            Ps = 2 6  -> Report Keyboard status as CSI ? 2 7  ;  1  ;  0  ;  0  n  (North American)
          The last two parameters apply to VT400 & up, and denote key-
          board ready and LK01 respectively.
            Ps = 5 3  -> Report Locator status as CSI ? 5 3  n  Locator available, if compiled-in, or
          CSI ? 5 0  n  No Locator, if not. */
CSI > Ps p
          Set resource value pointerMode, used by xterm to decide
          whether to hide the pointer cursor as the user types.  Valid
          values for the parameter:
            Ps = 0  -> never hide the pointer
            Ps = 1  -> hide if the mouse tracking mode is not enabled
            Ps = 2  -> always hide the pointer If no parameter is given,
          xterm uses the default, which is 1 .
          CSI r ; c R
CSI > Ps n
          Disable modifiers which may be enabled via the CSI > Ps; Ps m
          sequence.  This corresponds to a resource value of "-1", which
          cannot be set with the other sequence.  The parameter identi-
          fies the resource to be disabled:
            -> 1  modifyCursorKeys
            -> 2  modifyFunctionKeys
            -> 4  modifyOtherKeys If the parameter is omitted, modify-
          FunctionKeys is disabled.  When modifyFunctionKeys is dis-
          abled, xterm uses the modifier keys to make an extended
          sequence of functions rather than adding a parameter to each
          function key to denote the modifiers.


CSI Ps @  	doInsertBlankChar(%d);	//Insert Ps (Blank) Character(s) (default = 1) (ICH)
CSI Ps A  	doCursorUp(%d);		//Cursor Up Ps Times (default = 1) (CUU)
CSI Ps B  	doCursorDown(%d);	//Cursor Down Ps Times (default = 1) (CUD)
CSI Ps C  	doCursorFoward(%d);	//Cursor Forward Ps Times (default = 1) (CUF)
CSI Ps D  	doCursorBack(%d);	//Cursor Backward Ps Times (default = 1) (CUB)
CSI Ps E  	doCursor?? 			//Cursor Next Line Ps Times (default = 1) (CNL)
CSI Ps F  //Cursor Preceding Line Ps Times (default = 1) (CPL)
CSI Ps G  //Cursor Character Absolute  [column] (default = [row,1]) (CHA)
CSI Ps ; Ps H	doCursorPos(%d,%d);	//Cursor Position [row;column] (default = [1,1]) (CUP)
CSI Ps I  	//Cursor Forward Tabulation Ps tab stops (default = 1) (CHT)
CSI Ps J   /* Erase in Display (ED)
            Ps = 0  -> Erase Below (default)
            Ps = 1  -> Erase Above
            Ps = 2  -> Erase All
            Ps = 3  -> Erase Saved Lines (xterm) */
CSI Ps K  /* Erase in Line (EL)
            Ps = 0  -> Erase to Right (default)
            Ps = 1  -> Erase to Left
            Ps = 2  -> Erase All */
CSI Ps L  Insert Ps Line(s) (default = 1) (IL)
CSI Ps M  Delete Ps Line(s) (default = 1) (DL)
CSI Ps P  Delete Ps Character(s) (default = 1) (DCH)
CSI Ps S  Scroll up Ps lines (default = 1) (SU)
CSI Ps T  Scroll down Ps lines (default = 1) (SD)
CSI Ps ; Ps ; Ps ; Ps ; Ps T
          /* Initiate highlight mouse tracking.  Parameters are [func;startx;starty;firstrow;lastrow].  
		  See the section Mouse Tracking. */
CSI Ps X  Erase Ps Character(s) (default = 1) (ECH)
CSI Ps Z  Cursor Backward Tabulation Ps tab stops (default = 1) (CBT)
CSI Ps b  doRepeatChar(%d);	// Repeat the preceding graphic character Ps times (REP)
CSI Ps c  /* Send Device Attributes (Primary DA)
            Ps = 0  or omitted -> request attributes from terminal.  The
          response depends on the decTerminalID resource setting.
            -> CSI ? 1 ; 2 c  (``VT100 with Advanced Video Option'')
            -> CSI ? 1 ; 0 c  (``VT101 with No Options'')
            -> CSI ? 6 c  (``VT102'')
            -> CSI ? 6 0 ; 1 ; 2 ; 6 ; 8 ; 9 ; 1 5 ; c  (``VT220'')
          The VT100-style response parameters do not mean anything by
          themselves.  VT220 parameters do, telling the host what fea-
          tures the terminal supports:
            -> 1  132-columns
            -> 2  Printer
            -> 6  Selective erase
            -> 8  User-defined keys
            -> 9  National replacement character sets
            -> 1 5  Technical characters
            -> 2 2  ANSI color, e.g., VT525
            -> 2 9  ANSI text locator (i.e., DEC Locator mode) */

CSI Ps ; Ps f  //Horizontal and Vertical Position [row;column] (default = [1,1]) (HVP)
CSI Ps g  Tab Clear (TBC)
            Ps = 0  -> Clear Current Column (default)
            Ps = 3  -> Clear All

CSI Pm `  Character Position Absolute  [column] (default = [row,1]) (HPA)

CSI Pm m  Character Attributes (SGR)
            Ps = 0  -> Normal (default)
            Ps = 1  -> Bold
            Ps = 4  -> Underlined
            Ps = 5  -> Blink (appears as Bold)
            Ps = 7  -> Inverse
            Ps = 8  -> Invisible, i.e., hidden (VT300)
            Ps = 2 2  -> Normal (neither bold nor faint)
            Ps = 2 4  -> Not underlined
            Ps = 2 5  -> Steady (not blinking)
            Ps = 2 7  -> Positive (not inverse)
            Ps = 2 8  -> Visible, i.e., not hidden (VT300)
            Ps = 3 0  -> Set foreground color to Black
            Ps = 3 1  -> Set foreground color to Red
            Ps = 3 2  -> Set foreground color to Green
            Ps = 3 3  -> Set foreground color to Yellow
            Ps = 3 4  -> Set foreground color to Blue
            Ps = 3 5  -> Set foreground color to Magenta
            Ps = 3 6  -> Set foreground color to Cyan
            Ps = 3 7  -> Set foreground color to White
            Ps = 3 9  -> Set foreground color to default (original)
            Ps = 4 0  -> Set background color to Black
            Ps = 4 1  -> Set background color to Red
            Ps = 4 2  -> Set background color to Green
            Ps = 4 3  -> Set background color to Yellow
            Ps = 4 4  -> Set background color to Blue
            Ps = 4 5  -> Set background color to Magenta
            Ps = 4 6  -> Set background color to Cyan
            Ps = 4 7  -> Set background color to White
            Ps = 4 9  -> Set background color to default (original).

          If 16-color support is compiled, the following apply.  Assume
          that xterm's resources are set so that the ISO color codes are
          the first 8 of a set of 16.  Then the aixterm colors are the
          bright versions of the ISO colors:
            Ps = 9 0  -> Set foreground color to Black
            Ps = 9 1  -> Set foreground color to Red
            Ps = 9 2  -> Set foreground color to Green
            Ps = 9 3  -> Set foreground color to Yellow
            Ps = 9 4  -> Set foreground color to Blue
            Ps = 9 5  -> Set foreground color to Magenta
            Ps = 9 6  -> Set foreground color to Cyan
            Ps = 9 7  -> Set foreground color to White
            Ps = 1 0 0  -> Set background color to Black
            Ps = 1 0 1  -> Set background color to Red
            Ps = 1 0 2  -> Set background color to Green
            Ps = 1 0 3  -> Set background color to Yellow
            Ps = 1 0 4  -> Set background color to Blue
            Ps = 1 0 5  -> Set background color to Magenta
            Ps = 1 0 6  -> Set background color to Cyan
            Ps = 1 0 7  -> Set background color to White

          If xterm is compiled with the 16-color support disabled, it
          supports the following, from rxvt:
            Ps = 1 0 0  -> Set foreground and background color to
          default

          If 88- or 256-color support is compiled, the following apply.
            Ps = 3 8  ; 5  ; Ps -> Set foreground color to the second Ps
            Ps = 4 8  ; 5  ; Ps -> Set background color to the second Ps


CSI Pm h  Set Mode (SM)
            Ps = 2  -> Keyboard Action Mode (AM)
            Ps = 4  -> Insert Mode (IRM)
            Ps = 1 2  -> Send/receive (SRM)
            Ps = 2 0  -> Automatic Newline (LNM)
CSI ? Pm h
          DEC Private Mode Set (DECSET)
            Ps = 1  -> Application Cursor Keys (DECCKM)
            Ps = 2  -> Designate USASCII for character sets G0-G3(DECANM), and set VT100 mode.
            Ps = 3  -> 132 Column Mode (DECCOLM)
            Ps = 4  -> Smooth (Slow) Scroll (DECSCLM)
            Ps = 5  -> Reverse Video (DECSCNM)
            Ps = 6  -> Origin Mode (DECOM)
            Ps = 7  -> Wraparound Mode (DECAWM)
            Ps = 8  -> Auto-repeat Keys (DECARM)
            Ps = 9  -> Send Mouse X & Y on button press.  See the section Mouse Tracking.
            Ps = 1 0  -> Show toolbar (rxvt)
            Ps = 1 2  -> Start Blinking Cursor (att610)
            Ps = 1 8  -> Print form feed (DECPFF)
            Ps = 1 9  -> Set print extent to full screen (DECPEX)
            Ps = 2 5  -> Show Cursor (DECTCEM)
            Ps = 3 0  -> Show scrollbar (rxvt).
            Ps = 3 5  -> Enable font-shifting functions (rxvt).
            Ps = 3 8  -> Enter Tektronix Mode (DECTEK)
            Ps = 4 0  -> Allow 80 -> 132 Mode
            Ps = 4 1  -> more(1) fix (see curses resource)
            Ps = 4 2  -> Enable Nation Replacement Character sets (DECN-RCM)
            Ps = 4 4  -> Turn On Margin Bell
            Ps = 4 5  -> Reverse-wraparound Mode
            Ps = 4 6  -> Start Logging (normally disabled by a compile-time option)
            Ps = 4 7  -> Use Alternate Screen Buffer (unless disabled by the titeInhibit resource)
            Ps = 6 6  -> Application keypad (DECNKM)
            Ps = 6 7  -> Backarrow key sends backspace (DECBKM)
            Ps = 1 0 0 0  -> Send Mouse X & Y on button press and release.  See the section Mouse Tracking.
            Ps = 1 0 0 1  -> Use Hilite Mouse Tracking.
            Ps = 1 0 0 2  -> Use Cell Motion Mouse Tracking.
            Ps = 1 0 0 3  -> Use All Motion Mouse Tracking.
            Ps = 1 0 0 4  -> Send FocusIn/FocusOut events.
            Ps = 1 0 1 0  -> Scroll to bottom on tty output (rxvt).
            Ps = 1 0 1 1  -> Scroll to bottom on key press (rxvt).
            Ps = 1 0 3 4  -> Interpret "meta" key, sets eighth bit. (enables the eightBitInput resource).
            Ps = 1 0 3 5  -> Enable special modifiers for Alt and NumLock keys (enables the numLock resource).
            Ps = 1 0 3 6  -> Send ESC when Meta modifies a key (enables
          the metaSendsEscape resource).
            Ps = 1 0 3 7  -> Send DEL from the editing-keypad Delete key
            Ps = 1 0 3 9  -> Send ESC when Alt modifies a key (enables
          the altSendsEscape resource).
            Ps = 1 0 4 0  -> Keep selection even if not highlighted
          (enables the keepSelection resource).
            Ps = 1 0 4 1  -> Use the CLIPBOARD selection (enables the
          selectToClipboard resource).
            Ps = 1 0 4 2  -> Enable Urgency window manager hint when
          Control-G is received (enables the bellIsUrgent resource).
            Ps = 1 0 4 3  -> Enable raising of the window when Control-G
          is received (enables the popOnBell resource).
            Ps = 1 0 4 7  -> Use Alternate Screen Buffer (unless dis-
          abled by the titeInhibit resource)
            Ps = 1 0 4 8  -> Save cursor as in DECSC (unless disabled by
          the titeInhibit resource)
            Ps = 1 0 4 9  -> Save cursor as in DECSC and use Alternate
          Screen Buffer, clearing it first (unless disabled by the
          titeInhibit resource).  This combines the effects of the 1 0 4
          7  and 1 0 4 8  modes.  Use this with terminfo-based applica-
          tions rather than the 4 7  mode.
            Ps = 1 0 5 0  -> Set terminfo/termcap function-key mode.
            Ps = 1 0 5 1  -> Set Sun function-key mode.
            Ps = 1 0 5 2  -> Set HP function-key mode.
            Ps = 1 0 5 3  -> Set SCO function-key mode.
            Ps = 1 0 6 0  -> Set legacy keyboard emulation (X11R6).
            Ps = 1 0 6 1  -> Set VT220 keyboard emulation.
            Ps = 2 0 0 4  -> Set bracketed paste mode.
C
